/*
Copyright © 2020 NAME HERE <EMAIL ADDRESS>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
package cmd

import (
	"fmt"
	"github.com/spf13/cobra"
	"os"
	"path"
	"path/filepath"
	"pgm/config"
	"pgm/logger"

	homedir "github.com/mitchellh/go-homedir"
	"github.com/spf13/viper"
)

var cfgFile string

// rootCmd represents the base command when called without any subcommands
var rootCmd = &cobra.Command{
	Use:   "pgm",
	Short: "A brief description of your application",
	Long: `A longer description that spans multiple lines and likely contains
examples and usage of using your application. For example:

Cobra is a CLI library for Go that empowers applications.
This application is a tool to generate the needed files
to quickly create a Cobra application.`,
	// Uncomment the following line if your bare application
	// has an action associated with it:
	//	Run: func(cmd *cobra.Command, args []string) {},
}

// Execute adds all child commands to the root command and sets flags appropriately.
// This is called by main.main(). It only needs to happen once to the rootCmd.
func Execute() {
	if err := rootCmd.Execute(); err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}

func init() {
	var homeDirectory string
	homeDirectory, err := os.UserHomeDir()
	if err != nil {
		logger.Logger("[ERROR] unable to init with home directory")
	}
	cobra.OnInitialize(InitConfig)

	// Here you will define your flags and configuration settings.
	// Cobra supports persistent flags, which, if defined here,
	// will be global for your application.

	rootCmd.PersistentFlags().StringVar(&cfgFile, "hostCfgFile", "", "hostCfgFile file (default is $HOME/.pgm.yaml)")

	// Cobra also supports local flags, which will only run
	// when this action is called directly.
	rootCmd.Flags().BoolP("toggle", "t", false, "Help message for toggle")
	customPgm := viper.GetString("pgm_home_overide")
	if len(customPgm) > 0 {
		logger.Logger("[LOG] custom pgm overide set at: " + customPgm)
		if filepath.IsAbs(customPgm) != true {
			logger.Logger("[ERROR] failed to add non absolute path to viper")
		} else {
			viper.AddConfigPath(customPgm)
			pgmDir := viper.GetString("pgm_dir")
			logsDir := viper.GetString("logs_dir")
			hostsDir := viper.GetString("hosts_dir")
			viper.SetDefault("logsDir", customPgm + "/" + logsDir)
			viper.SetDefault("pgmDir", customPgm + pgmDir)
			viper.SetDefault("hostsDir", customPgm + pgmDir + "/" + hostsDir)
		}
	}
	viper.AddConfigPath(path.Join(homeDirectory))
	viper.SetConfigName(".pgm")
	viper.SetDefault("homeDir", homeDirectory)
	err = viper.ReadInConfig()
	if err != nil {
		logger.Logger("[ERROR] viper hostCfgFile issue" + err.Error())
	}
	pgmDir := viper.GetString("pgm_dir")
	logsDir := viper.GetString("logs_dir")
	hostsDir := viper.GetString("hosts_dir")
	cfgDir := viper.GetString("cfg_dir")
	viper.SetDefault("pgmDir", homeDirectory + pgmDir)
	viper.SetDefault("hostsDir", homeDirectory + pgmDir + "/" + hostsDir)
	viper.SetDefault("cfgDir", homeDirectory + pgmDir + "/" + cfgDir)
	viper.SetDefault("logsDir", homeDirectory + pgmDir + "/" + logsDir)



}

// initConfig reads in hostCfgFile file and ENV variables if set.
func InitConfig() {
	if cfgFile != "" {
		// Use hostCfgFile file from the flag.
		viper.SetConfigFile(cfgFile)
	} else {
		// Find home directory.
		home, err := homedir.Dir()
		if err != nil {
			fmt.Println(err)
			os.Exit(1)
		}
		// Search hostCfgFile in home directory with name ".pgm" (without extension).
		viper.AddConfigPath(home)
		viper.SetConfigName(".pgm")

	}
	var hosts string
	var cfg string
	var logs string
	var pgm string
	hosts = viper.GetString("hostsDir")
	cfg = viper.GetString("cfgDir")
	logs = viper.GetString("logsDir")
	pgm = viper.GetString("pgmDir")
	s := []string{hosts, cfg, logs, pgm}

	config.IsInit(s)

	viper.AutomaticEnv() // read in environment variables that match

	// If a hostCfgFile file is found, read it in.
	if err := viper.ReadInConfig(); err == nil {
		logger.Logger("[LOG] Using hostCfgFile file:"+  viper.ConfigFileUsed())
	}
}
